////        (C) Copyright 1996,1997 Custom Computer Services            ////

//// This source code may only be used by licensed users of the CCS C   ////

//// compiler.  This source code may only be distributed to other       ////

//// licensed users of the CCS C compiler.  No other use, reproduction  ////

//// or distribution is permitted without written permission.           ////

//// Derivative programs created using this software in object code     ////

//// form are not restricted in any way.                                ////

////////////////////////////////////////////////////////////////////////////



#ifndef _stdlib_



#define _stdlib_ true



float atof(char * s) {

 float pow10;

        float result;

 int sign, point;

 char c;

        int ptr;



        ptr=0;

    sign = 0;

 point = 0;

 pow10 = 1.0;

    result = 0.0;



 do

          c=s[ptr++];

        while ((c<'0'||c>'9') && c!='+' && c!='-' && c!='.');



 while((c>='0' && c<='9') || c=='+' || c=='-' || c=='.') {

           if(c == '-') {

              sign = 1;

              c = s[ptr++];

           }



           while((c >= '0' && c <= '9') && point == 0) {

              result = 10*result + c - '0';

              c = s[ptr++];

           }



           if (c == '.') {

              point = 1;

              c = s[ptr++];

           }



    while((c >= '0' && c <= '9') && point == 1) {

        pow10 = pow10*10;

               result += (c - '0')/pow10;

               c = s[ptr++];

           }

        }



 if (sign == 1)

      result = -1*result;



 return(result);

}



#define labs abs

#define fabs abs



/************************************************************/



signed int atoi(char *s)

{

   signed int result;

   int sign, base, index;

   char c;



   index = 0;

   sign = 0;

   base = 10;

   result = 0;



   // Omit all preceeding alpha characters

   do

      c = s[index++];

   while ((c < '0' || c > '9') && c != '+' && c != '-');



   // increase index if either positive or negative sign is detected

   if (c == '-')

   {

      sign = 1;         // Set the sign to negative

      c = s[index++];

   }

   else if (c == '+')

   {

      c = s[index++];

   }



   if (c >= '0' && c <= '9')

   {



      // Check for hexa number

      if (c == '0' && (s[index] == 'x' || s[index] == 'X'))

      {

         base = 16;

         index++;

         c = s[index++];

      }



      // The number is a decimal number

      if (base == 10)

      {

         while (c >= '0' && c <= '9')

         {

            result = 10*result + (c - '0');

            c = s[index++];

         }

      }

      else if (base == 16)    // The number is a hexa number

      {

         while (c = TOUPPER(c), (c >= '0' && c <= '9') || (c >= 'A' && c<='F'))

         {

            if (c >= '0' && c <= '9')

               result = (result << 4) + (c - '0');

            else

               result = (result << 4) + (c - 'A' + 10);



            c = s[index++];

         }

      }

   }



   if (sign == 1 && base == 10)

       result = -result;



   return(result);

}







signed long atol(char *s)

{

   signed long result;

   int sign, base, index;

   char c;



   index = 0;

   sign = 0;

   base = 10;

   result = 0;



   do

      c = s[index++];

   while ((c < '0' || c>'9') && c != '+' && c != '-');



   // increase index if either positive or negative sign is detected

   if (c == '-')

   {

      sign = 1;         // Set the sign to negative

      c = s[index++];

   }

   else if (c == '+')

   {

      c = s[index++];

   }



   if (c >= '0' && c <= '9')

   {

      if (c == '0' && (s[index] == 'x' || s[index] == 'X'))

      {

         base = 16;

         index++;

         c = s[index++];

      }



      // The number is a decimal number

      if (base == 10)

      {

         while (c >= '0' && c <= '9')

         {

            result = 10*result + (c - '0');

            c = s[index++];

         }

      }

      else if (base == 16)    // The number is a hexa number

      {

         while (c = TOUPPER(c), (c >= '0' && c <= '9') || (c >= 'A' && c <='F'))

         {

            if (c >= '0' && c <= '9')

               result = (result << 4) + (c - '0');

            else

               result = (result << 4) + (c - 'A' + 10);



            c = s[index++];

         }

      }

   }



   if (base == 10 && sign == 1)

      result = -result;



   return(result);

}



signed int32 mult_with10(int32 num)

{

   return ( (num << 1) + (num << 3) );

}



signed int32 atoi32(char *s)

{

   signed int32 result;

   int sign, base, index;

   char c;



   index = 0;

   sign = 0;

   base = 10;

   result = 0;



   do

      c = s[index++];

   while ((c < '0' || c>'9') && c != '+' && c != '-');



   // increase index if either positive or negative sign is detected

   if (c == '-')

   {

      sign = 1;         // Set the sign to negative

      c = s[index++];

   }

   else if (c == '+')

   {

      c = s[index++];

   }



   if (c >= '0' && c <= '9')

   {

      if (c == '0' && (s[index] == 'x' || s[index] == 'X'))

      {

         base = 16;

         index++;

         c = s[index++];

      }



      // The number is a decimal number

      if (base == 10)

      {

         while (c >= '0' && c <= '9') {

            result = (result << 1) + (result << 3);  // result *= 10;

            result += (c - '0');

            c = s[index++];

         }

      }

      else if (base == 16)    // The number is a hexa number

      {

         while (c = TOUPPER(c), (c >= '0' && c <= '9') || (c >= 'A' && c <='F'))

         {

            if (c >= '0' && c <= '9')

               result = (result << 4) + (c - '0');

            else

               result = (result << 4) + (c - 'A' + 10);



            c = s[index++];

         }

      }

   }



   if (base == 10 && sign == 1)

      result = -result;



   return(result);

}





#endif

